'use strict'

// singleton
// defines the forbidden operations
class ForbiddenOperations {
  
  static initConstants() {
    this._singletonEnforcer = Symbol();
  }
  
  static get instance() {
    if ( ! this._instance ) { 
      this._instance = new ForbiddenOperations(this._singletonEnforcer);
    }
    return this._instance;
  }
  
  constructor(enforcer) {
    if (enforcer != this.constructor._singletonEnforcer)
      throw new Error("cannot construct singleton. use static method 'instance' instead");
    
    this.clear();
  }
  
  clear() {
    this.forbidden = {};
  }
  
  // operation is one of the SPJRUD
  forbid(operation) {
    operation = operation.toUpperCase();
    this.forbidden[operation] = true;
  }
  
  isForbidden(operation) {
    return this.forbidden[operation.toUpperCase()] === true;
  }
}


ForbiddenOperations.initConstants();