class Parser {
  static load(filename, callback) {
    filename = "./js/tests/parser/parser.peg";
    $.get(filename, function(data){
      try {
        let parser = new Parser(data);
        let originalParse = parser.parse;
        parser.parse = (input) => {
          try{
            Expression.resetCounter();
            return originalParse.call(parser, input);
          }
          catch (err) {
            // console.log("Error : ", err instanceof Error);
            // console.log("CAUGHT PARSING ERROR", err, typeof err, err.constructor.name);
            
            if (err instanceof AlgebraError) {
              console.log("algebra error occured, should be wrapped in SqfError", err.description);
              throw err;
            }
            else if (err instanceof Error) {
              let sqfError = new SqfError(SqfError.SYNTAX, {
                location: err.location,
                description: err.message,
              });
              throw sqfError;
            }
            else {
              throw err;
            }
          }
        };
        callback(parser);
      }
      catch (err){
        console.log(`Grammar error: ${err} at ${err.location.start.line}`);
        throw err;
      }
    });
  }
  
  constructor ( grammar ) {
      return PEG.buildParser(grammar);
  }
 
}



