'use strict'

QUnit.module( "Forbidden operations" );

QUnit.test("singleton instance", function( assert ) {
  let inst = ForbiddenOperations.instance;
  
  inst.clear();
  
  assert.ok(inst instanceof ForbiddenOperations);
  assert.ok(!inst.isForbidden("S"));
  assert.ok(!inst.isForbidden("P"));
  assert.ok(!inst.isForbidden("J"));
  assert.ok(!inst.isForbidden("R"));
  assert.ok(!inst.isForbidden("U"));
  assert.ok(!inst.isForbidden("D"));
});

QUnit.test("instantiation", function( assert ) {
  assert.throws(
    () => {
      let o = new ForbiddenOperations();
    },
    Error,
    "cannot instanciate singleton"
  );
});



QUnit.test("Forbidding operations", function( assert ) {
  let inst = ForbiddenOperations.instance;
  
  inst.clear();
  
  assert.ok(inst instanceof ForbiddenOperations);
  assert.ok(!inst.isForbidden("S"));
  assert.ok(!inst.isForbidden("P"));
  assert.ok(!inst.isForbidden("J"));
  assert.ok(!inst.isForbidden("R"));
  assert.ok(!inst.isForbidden("U"));
  assert.ok(!inst.isForbidden("D"));
  
  inst.forbid("s");
  assert.ok(inst.isForbidden("S"));
  assert.ok(!inst.isForbidden("P"));
  assert.ok(!inst.isForbidden("J"));
  assert.ok(!inst.isForbidden("R"));
  assert.ok(!inst.isForbidden("U"));
  assert.ok(!inst.isForbidden("D"));
  
  inst.forbid("p");
  assert.ok(inst.isForbidden("S"));
  assert.ok(inst.isForbidden("P"));
  assert.ok(!inst.isForbidden("J"));
  assert.ok(!inst.isForbidden("R"));
  assert.ok(!inst.isForbidden("U"));
  assert.ok(!inst.isForbidden("D"));
  
  inst.forbid("j");
  assert.ok(inst.isForbidden("S"));
  assert.ok(inst.isForbidden("P"));
  assert.ok(inst.isForbidden("J"));
  assert.ok(!inst.isForbidden("R"));
  assert.ok(!inst.isForbidden("U"));
  assert.ok(!inst.isForbidden("D"));
  
  inst.forbid("r");
  assert.ok(inst.isForbidden("S"));
  assert.ok(inst.isForbidden("P"));
  assert.ok(inst.isForbidden("J"));
  assert.ok(inst.isForbidden("R"));
  assert.ok(!inst.isForbidden("U"));
  assert.ok(!inst.isForbidden("D"));
  
  inst.forbid("u");
  assert.ok(inst.isForbidden("S"));
  assert.ok(inst.isForbidden("P"));
  assert.ok(inst.isForbidden("J"));
  assert.ok(inst.isForbidden("R"));
  assert.ok(inst.isForbidden("U"));
  assert.ok(!inst.isForbidden("D"));
  
  inst.forbid("d");
  assert.ok(inst.isForbidden("S"));
  assert.ok(inst.isForbidden("P"));
  assert.ok(inst.isForbidden("J"));
  assert.ok(inst.isForbidden("R"));
  assert.ok(inst.isForbidden("U"));
  assert.ok(inst.isForbidden("D"));
});

