'use strict'

QUnit.module( "Union" );

QUnit.test("full example", function( assert ) {
  let leftSchema = new Schema("id", "prénom", "nom");
  let rightSchema = new Schema("nom", "id", "prénom");
  
  
  let leftTuples = [
    new Tuple("1", "Sergio",      "Mazzoleni"),
    new Tuple("2", "Christophe",  "Dhondt"),
    new Tuple("3", "Emmanuel",    "Duez"),
  ];
  
  let rightTuples = [
    new Tuple("Mazzoleni",      "1", "Sergio"),
    new Tuple("Petit-Barreau",  "4", "Thomas"),
    new Tuple("Deleuze",        "5", "Jonathan"),
  ];
  
  let leftExpr = new Relation({
      schema: leftSchema, 
      tupleSet: new TupleSet(leftTuples) 
  });
  
  let rightExpr = new Relation({
      schema: rightSchema, 
      tupleSet: new TupleSet(rightTuples) 
  });
      
  let union = new Union({
    leftExpression: leftExpr, 
    rightExpression: rightExpr,
  });
  
  assert.equal(union.tupleSet.size, 5);
  
  console.log(union.toString());
});

